#include <PwmWrite.h>
#include <SoundWrite.h>
#include <Delay.h>
#include <Filter.h>
#include <Random.h>

int main()
{
	PwmWrite ledSmallLeft = PwmWrite (2);
	PwmWrite ledBigLeft = PwmWrite (1);
	PwmWrite ledSmallRight = PwmWrite (18);
	PwmWrite ledBigRight = PwmWrite (19);
	Filter filterLedSmallLeft = Filter (50, true);
	Filter filterLedBigLeft = Filter (200, true);
	Filter filterLedSmallRight = Filter (50, true);
	Filter filterLedBigRight = Filter (200, true);
	unsigned int usLedSmallLeft = 0;
	unsigned int usLedBigLeft = 0;
	unsigned int usLedSmallRight = 0;
	unsigned int usLedBigRight = 0;
	unsigned char countSound = 0;
	unsigned char iterationSound = 0;
	Delay delayLedSmallLeft = Delay (0, true);
	Delay delayLedBigLeft = Delay (0, true);
	Delay delayLedSmallRight = Delay (0, true);
	Delay delayLedBigRight = Delay (0, true);
	Delay delaySound = Delay (0, true);
	
	PwmWrite::start (100);
	SoundWrite::pin (10);
	Random::seed (20);
	
	while (true)
	{
		delayLedSmallLeft.state();
		delayLedBigLeft.state();
		delayLedSmallRight.state();
		delayLedBigRight.state();
		delaySound.state();
		
		filterLedSmallLeft.set (usLedSmallLeft);
		ledSmallLeft.us (filterLedSmallLeft.value);
		
		if (delayLedSmallLeft.update == true)
		{
			usLedSmallLeft = Random::integer (100, 2500);
			delayLedSmallLeft.duration (Random::integer (50, 500));
		}
		
		filterLedBigLeft.set (usLedBigLeft);
		ledBigLeft.us (filterLedBigLeft.value);
		
		if (delayLedBigLeft.update == true)
		{
			usLedBigLeft = Random::integer (100, 2500);
			delayLedBigLeft.duration (Random::integer (500, 5000));
		}
		
		filterLedSmallRight.set (usLedSmallRight);
		ledSmallRight.us (filterLedSmallRight.value);
		
		if (delayLedSmallRight.update == true)
		{
			usLedSmallRight = Random::integer (100, 2500);
			delayLedSmallRight.duration (Random::integer (50, 500));
		}
		
		filterLedBigRight.set (usLedBigRight);
		ledBigRight.us (filterLedBigRight.value);
		
		if (delayLedBigRight.update == true)
		{
			usLedBigRight = Random::integer (100, 2500);
			delayLedBigRight.duration (Random::integer (500, 5000));
		}
		
		if (delaySound.update == true)
		{
			countSound = Random::integer (1, 16);
			
			for (iterationSound = 0; iterationSound < countSound; iterationSound++)
			{
				if (iterationSound != 0)
				{
					SoundWrite::add (0, Random::integer (25, 75));
				}
				
				SoundWrite::add (Random::integer (32, 1536), Random::integer (25, 75));
			}
			
			SoundWrite::play (0, 0);
			
			delaySound.duration (Random::integer (3000, 30000));
		}
	}
	
	return 0;
}
